/* The order of this does NOT matter, but do not give things specific values
 * or you will screw up the ability to count things properly */
enum e_ArchBaseToken {
	AT_CLB_GRID,
	AT_IO_RAT, 
	AT_CHAN_WIDTH_IO, 
	AT_CHAN_WIDTH_X, 
	AT_CHAN_WIDTH_Y, 
	AT_OUTPIN, 
	AT_INPIN, 
	AT_SUBBLOCKS_PER_CLB, 
	AT_SUBBLOCK_LUT_SIZE, 
	AT_FC_TYPE, 
	AT_FC_OUTPUT, 
	AT_FC_INPUT, 
	AT_FC_PAD, 
	AT_FS, 
	AT_SWITCH_BLOCK_TYPE, 
	AT_SEGMENT, 
	AT_SWITCH, 
	AT_R_MINW_NMOS, 
	AT_R_MINW_PMOS, 
	AT_C_IPIN_SBLOCK,
	AT_T_IPIN_CBLOCK, 
	AT_T_SBLK_OPIN_TO_SBLK_IPIN, 
	AT_T_CLB_IPIN_TO_SBLK_IPIN, 
	AT_T_SBLK_OPIN_TO_CLB_OPIN, 
	AT_T_IPAD, 
	AT_T_OPAD, 
	AT_T_SUBBLOCK, 
	AT_IPIN_MUX_TRANS_SIZE,
	AT_CLB_AREA,
	AT_BASE_UNKNOWN /* Must be last since used for counting enum items */
};


enum e_ArchToken {
	AT_AUTO,
	AT_UNIFORM, 
	AT_DELTA, 
	AT_GAUSSIAN, 
	AT_PULSE, 
	AT_CLASS, 
	AT_GLOBAL,
	AT_LEFT, 
	AT_TOP, 
	AT_RIGHT, 
	AT_BOTTOM, 
	AT_FRACTIONAL, 
	AT_ABSOLUTE,
	AT_SUBSET, 
	AT_WILTON, 
	AT_UNIVERSAL, 
	AT_FULL,
	AT_FREQUENCY, 
	AT_LENGTH, 
	AT_LONGLINE, 
	AT_WIRE_SWITCH, 
	AT_OPIN_SWITCH, 
	AT_FRAC_CB, 
	AT_FRAC_SB,
	AT_RMETAL, 
	AT_CMETAL,
	AT_DIRECTIONALITY, 
	AT_UNI_DIRECTIONAL,
	AT_BI_DIRECTIONAL, 
	AT_BUFFERED,
	AT_YES,
	AT_NO,
	AT_R, 
	AT_CIN, 
	AT_COUT, 
	AT_TDEL,
	AT_T_COMB, 
	AT_T_SEQ_IN, 
	AT_T_SEQ_OUT,
	AT_BUF_SIZE,
	AT_MUX_TRANS_SIZE,
	AT_ARG_UNKNOWN /* Must be last since used for counting enum items */
};


extern const struct s_TokenPair ArchBaseTokenList[];
extern const struct s_TokenPair ArchArgTokenList[];


char** ReadLineTokens(INOUT FILE *InFile, INOUT int *LineNum);
